

/*++

	Copyright (C) Fur, 2007

:

	pe.h

:

	        PE-

	   :
	ntinside.narod.ru

	        
	


--*/

#ifndef _PE_H
#define _PE_H

#include <windows.h>


typedef enum
{
	PeLoadingTypeAsLibrary = 1,		//        LoadLibrary
									//      ,    
									//           
									// OFFSET  RVA  
	
	PeLoadingTypeAsBinary = 2		//        (  CreateFile, ReadFile)
									// OFFSET    RVA   
} PE_LOADING_TYPE;


typedef struct _PE_EXPORT_SYMBOL
{
	CHAR *szSymbolName;			//  , . NULL (     )
	DWORD dwRVA;				// RVA 
	DWORD dwOrdinal;			// ORDINAL 
	struct _PE_EXPORT_SYMBOL *pNext;
} PE_EXPORT_SYMBOL, *PEXPORT_SYMBOL;


typedef struct  
{
	CHAR *szDllName;
	DWORD dwTimeStamp;
	DWORD dwFunctionNames;
	DWORD dwFunctionCount;
	DWORD dwOrdinalBase;

	PE_EXPORT_SYMBOL *pExports;

} PE_EXPORT_INFO;



typedef struct  
{
	PVOID				ImageBase;
	PE_LOADING_TYPE		LoadingType;
} PE_IMAGE;




BOOL
PeLoadImage(
	IN TCHAR *szPeFile,
	IN PE_LOADING_TYPE LoadingType,
	OUT PE_IMAGE* pImage
	);


VOID
PeUnloadImage(
	IN PE_IMAGE* pImage
	);


PVOID
PeGetVA(
	IN PE_IMAGE* pImage,
	IN ULONG RVA 
	);


PE_EXPORT_INFO*
PeEnumerateExports(
	IN PE_IMAGE *pImage
	);


VOID
PeFreeExports(
	PE_EXPORT_INFO *pInfo
	);

#endif // _PE_H
