
/*++

	Copyright (C) Fur, 2007

:

	sdt.h

:

	          
	  SDT

	   :
	ntinside.narod.ru

	        
	


--*/

#ifndef _SDT_H
#define _SDT_H

#include <tchar.h>
#include <windows.h>
#include <stdio.h>

#include "pe.h"



#define SDT_FUNCTION_NOT_IN_SDT			((DWORD)-1)
#define SDT_FUNCTION_NOT_PRESENT		((DWORD)-2)

typedef struct _SDT_FUNCTION_INFO
{
	CHAR	*szFunctionName;
	DWORD	dwNumWin2000;
	DWORD	dwNumWinXP;
	DWORD   dwNumWin2003;
	DWORD	dwNumWinVista;
	struct _SDT_FUNCTION_INFO *pNext;
} SDT_FUNCTION_INFO, *PSDT_FUNCTION_INFO;
//
//     dwNumWin2000, dwNumWinXP, dwNumWin2003  dwNumWinVista
//       SDT  SDT_FUNCTION_NOT_IN_SDT, 
//          Usermode
//        ,   
//  SDT_FUNCTION_NOT_PRESENT
//



typedef enum
{
	SdtSystemWindows2000 = 1,
	SdtSystemWindowsXP,
	SdtSystemWindows2003,
	SdtSystemWindowsVista
} SDT_SYSTEM_VER;





VOID
SdtFillFunctionInfo(
	IN OUT PSDT_FUNCTION_INFO *ppFirst,
	IN PE_IMAGE *pImage,
	IN PE_EXPORT_SYMBOL *pSymbols,
	IN SDT_SYSTEM_VER SystemVer,
	IN BOOL bExcludeZwFunctions
	);


VOID
SdtFreeFunctionInfo(
	IN PSDT_FUNCTION_INFO pInfo
	);



BOOL
SdtProcessDll(
	IN OUT PSDT_FUNCTION_INFO *ppFirst,
	IN TCHAR *szDllFile,
	IN SDT_SYSTEM_VER SystemVer
	);


PSDT_FUNCTION_INFO
SdtInspectDlls(
	IN TCHAR *szDllWindows2000,
	IN TCHAR *szDllWindowsXP,
	IN TCHAR *szDllWindows2003,
	IN TCHAR *szDllWindowsVista
	);

VOID
SdtPrintTable(
	IN PSDT_FUNCTION_INFO pInfo,
	IN BOOL bHexNumbers
	);




#endif // _SDT_H
